/* int^WIntSeti\[Xj*/

#include <stdio.h>
#include <stdlib.h>
#include "IntSet.h"

/*--- RgɁ̂֐K7-1Œǉꂽ֐ł ---*/

/*--- W̏ ---*/
int Initialize(IntSet *s, int max)
{
	s->num = 0;
	if ((s->set = calloc(max, sizeof(int))) == NULL) {
		s->max = 0;								/* z̊mۂɎs */
		return -1;
	}
	s->max = max;
	return 0;
}

/*--- WsnĂ邩 ---*/
int IsMember(const IntSet *s, int n)
{
	int i;

	for (i = 0; i < s->num; i++)
		if (s->set[i] == n)
			return i;			/* ܂܂iYԋpj*/
	return -1;					/* ܂܂Ȃ */
}

/*--- Ws͖tivfǉłȂԁj ---*/
int IsFull(const IntSet *s)
{
	return s->num >= s->max;
}

/*--- Wsnǉ ---*/
void Add(IntSet *s, int n)
{
	if (s->num < s->max && IsMember(s, n) == -1)	/* ܂܂Ȃ */
		s->set[s->num++] = n;						/* z̖ɒǉ */
}

/*--- Wsn폜 ---*/
void Remove(IntSet *s, int n)
{
	int idx;

	if ((idx = IsMember(s, n)) != -1) {
		s->set[idx] = s->set[--s->num];		/* ̗vf폜ʒuɈړ */
	}
}

/*--- Wsi[łő̗vf ---*/
int Capacity(const IntSet *s)
{
	return s->max;
}

/*--- Ws̗vf ---*/
int Size(const IntSet *s)
{
	return s->num;
}

/*--- Ws2s1ɑ ---*/
void Assign(IntSet *s1, const IntSet *s2)
{
	int i;
	int n = (s1->max < s2->num) ? s1->max : s2->num;	/* Rs[vf */

	for (i = 0; i < n; i++)
		s1->set[i] = s2->set[i];
	s1->num = n;
}

/*--- Ws1s2͓ ---*/
int Equal(const IntSet *s1, const IntSet *s2)
{
	int i, j;

	if (Size(s1) != Size(s2))
		return 0;

	for (i = 0; i < s1->num; i++) {
		for (j = 0; j < s2->num; j++)
			if (s1->set[i] == s2->set[j])
				break;
		if (j == s2->num)
			return 0;
	}
	return 1;
}

/*--- Ws2s3̘aWs1ɑ ---*/
IntSet *Union(IntSet *s1, const IntSet *s2, const IntSet *s3)
{
	int i;

	Assign(s1, s2);
	for (i = 0; i < s3->num; i++)
		Add(s1, s3->set[i]);

	return s1;
}

/*--- Ws2s3̐ϏWs1ɑ ---*/
IntSet *Intersection(IntSet *s1, const IntSet *s2, const IntSet *s3)
{
	int i, j;

	s1->num = 0;			/* s1Wɂ */
	for (i = 0; i < s2->num; i++)
		for (j = 0; j < s3->num; j++)
			if (s2->set[i] == s3->set[j])
				Add(s1, s2->set[i]);
	return s1;
}

/*--- Ws2s3Ws1ɑ ---*/
IntSet *Difference(IntSet *s1, const IntSet *s2, const IntSet *s3)
{
	int i, j;

	s1->num = 0;			/* s1Wɂ */
	for (i = 0; i < s2->num; i++) {
		for (j = 0; j < s3->num; j++)
			if (s2->set[i] == s3->set[j])
				break;
		if (j == s3->num)
			Add(s1, s2->set[i]);
	}
	return s1;
}

/*--- Ws2s3̑Ώۍs1ɑ ---*/
IntSet *SymmetricDifference(IntSet *s1, const IntSet *s2, const IntSet *s3)
{
	int i;

	s1->num = 0;			/* s1Wɂ */

	for (i = 0; i < s2->num; i++)
		if (IsMember(s3, s2->set[i]) == -1)
			Add(s1, s2->set[i]);

	for (i = 0; i < s3->num; i++)
		if (IsMember(s2, s3->set[i]) == -1)
			Add(s1, s3->set[i]);

	return s1;
}

/*--- Ws1ɑ΂ďWs2̑Svfǉ ---*/
IntSet *ToUnion(IntSet *s1, const IntSet *s2)
{
	int i;

	for (i = 0; i < s2->num; i++)
		Add(s1, s2->set[i]);

	return s1;
}

/*--- Ws1Ws2Ɋ܂܂ȂSvf폜 ---*/
IntSet *ToIntersection(IntSet *s1, const IntSet *s2)
{
	int i = 0;

	while (i < s1->num) {
		if (IsMember(s2, s1->set[i]) == -1)
			Remove(s1, s1->set[i]);
		else
			i++;
	}
	return s1;
}

/*--- Ws1Ws2Ɋ܂܂Svf폜 ---*/
IntSet *ToDifference(IntSet *s1, const IntSet *s2)
{
	int i;

	for (i = 0; i < s2->num; i++)
		Remove(s1, s2->set[i]);

	return s1;
}

/*--- Ws1s2̕W ---*/
int IsSubset(const IntSet *s1, const IntSet *s2)
{
	int i, j;

	for (i = 0; i < s1->num; i++) {
		for (j = 0; j < s2->num; j++)
			if (s1->set[i] == s2->set[j])
				break;
		if (j == s2->num)					/* s1->set[i]s2Ɋ܂܂Ȃ */
			return 0;
	}
	return 1;
}

/*--- Ws1s2̐^W ---*/
int IsProperSubset(const IntSet *s1, const IntSet *s2)
{
	int i;

	if (s1->num >= s2->num)					/* s1̗vfs2ȏł */
		return 0;							/* s1s2̐^Wł͂Ȃ */

	return IsSubset(s1, s2);
}

/*--- Ws̑Svf\ ---*/
void Print(const IntSet *s)
{
	int i;

	printf("{ ");
	for (i = 0; i < s->num; i++)
		printf("%d ", s->set[i]);
	printf("}");
}

/*--- Ws̑Svf\istj---*/
void PrintLn(const IntSet *s)
{
	Print(s);
	putchar('\n');
}

/*--- Ws̑Svf폜 ---*/
void Clear(IntSet *s)
{
	s->num = 0;
}

/*--- W̌n ---*/
void Terminate(IntSet *s)
{
	if (s->set != NULL) {
		free(s->set);							/* z */
		s->max = s->num = 0;
	}
}
